<?php

declare(strict_types=1);

namespace mirzaev\ebala\models\traits;

use exception;

/**
 * Заготовка для инициализации статуса
 *
 * @package mirzaev\ebala\controllers\traits
 * @author Arsen Mirzaev Tatyano-Muradovich <arsen@mirzaev.sexy>
 */
trait status
{
	/**
	 * Инициализировать статус 
	 *
	 * @param array &$errors Реестр ошибок
	 *
	 * @return ?bool Статус (null - не найден)
	 */
	public function status(array &$errors = []): ?bool
	{
		try {
			// Чтение и возврат (успех)
			return $this->document->active ?? false;
		} catch (exception $e) {
			// Запись в реестр ошибок
			$errors[] = [
				'text' => $e->getMessage(),
				'file' => $e->getFile(),
				'line' => $e->getLine(),
				'stack' => $e->getTrace()
			];
		}

		// Возврат (провал)
		return null;
	}
}
